package handlerActivationBugTest.handlers;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import org.eclipse.e4.core.contexts.Active;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.advanced.MPerspective;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledItem;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;

public class HandlerA {
	
	@Execute
	public void execute(EPartService partService, EModelService modelService,
			MApplication application) {
		MPerspective perspective = (MPerspective) modelService.find(
				"perspectiveB", application);
		partService.switchPerspective(perspective);
	}

	@Inject
	public void bla(
			@Optional @Active @Named("handler::testCommand") Object value,
			EModelService modelService, MApplication application) {
		if (value == null)
			return;
		List<MHandledItem> findElements = modelService.findElements(
				application, null, MHandledItem.class, null);
		for (MHandledItem mHandledItem : findElements) {
			mHandledItem.setLabel("perspectiveA");
			mHandledItem.setTooltip("perspectiveA now active");
		}
	}
}